OGRE-Next: Ogre::TextureDefinitionBase Class Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::TextureDefinitionBase Class Reference
Core » Effects

Centralized class for dealing with declarations of textures in Node & Workspace definitions. More...

`#include <OgreTextureDefinition.h>`

Inheritance diagram for Ogre::TextureDefinitionBase:
[legend]

## Classes
struct | BufferDefinition
class | TextureDefinition
| Local texture definition. More...

## Public Types
typedef vector< BufferDefinition >::type | BufferDefinitionVec
typedef vector< PixelFormatGpu >::type | PixelFormatGpuVec
typedef vector< TextureDefinition >::type | TextureDefinitionVec
enum | TextureSource { TEXTURE_INPUT , TEXTURE_LOCAL , TEXTURE_GLOBAL , NUM_TEXTURES_SOURCES }

## Public Member Functions
| TextureDefinitionBase (TextureSource defaultSource)
void | addBufferDefinition (IdString name, size_t numElements, uint32 bytesPerElement, uint32 bindFlags, float widthFactor, float heightFactor)
| Creates an UAV buffer.
virtual void | addBufferInput (size_t inputChannel, IdString name)
| Buffers.
RenderTargetViewDef * | addRenderTextureView (IdString name)
TextureDefinition * | addTextureDefinition (const String &name)
| Creates a TextureDefinition with a given name, must be unique.
virtual IdString | addTextureSourceName (const String &name, size_t index, TextureSource textureSource)
| Adds a texture name, whether a real one or an alias, and where to grab it from.
const BufferDefinitionVec & | getLocalBufferDefinitions () const
BufferDefinitionVec & | getLocalBufferDefinitionsNonConst ()
| Returns the local buffer definitions.
const TextureDefinitionVec & | getLocalTextureDefinitions () const
TextureDefinitionVec & | getLocalTextureDefinitionsNonConst ()
| Returns the local texture definitions.
const NameToChannelMap & | getNameToChannelMap () const
size_t | getNumInputBufferChannels () const
size_t | getNumInputChannels () const
| This has O(N) complexity! (not cached, we look in mNameToChannelMap).
const RenderTargetViewDef * | getRenderTargetViewDef (IdString name) const
RenderTargetViewDef * | getRenderTargetViewDefNonConstNoThrow (IdString name)
void | getTextureSource (IdString name, size_t &index, TextureSource &textureSource) const
| Retrieves in which container to look for when looking to which texture is a given name associated with.
void | removeAllRenderTextureViews ()
virtual void | removeBuffer (IdString name)
| Remove a buffer. Buffer can come from an input channel, or a locally defined one.
void | removeRenderTextureView (IdString name)
virtual void | removeTexture (IdString name)
| WARNING: Be very careful with this function.
void | renameBuffer (IdString oldName, const String &newName)
| Changes the name of a buffer.
void | renameTexture (IdString oldName, const String &newName)
| Changes the name of a texture.
void | setNumLocalBufferDefinitions (size_t numTDs)
| Reserves enough memory for all texture definitions.
void | setNumLocalTextureDefinitions (size_t numTDs)
| Reserves enough memory for all texture definitions.

## Static Public Member Functions
static UavBufferPacked * | createBuffer (const BufferDefinition &bufferDef, const TextureGpu *finalTarget, VaoManager *vaoManager)
static void | createBuffers (const BufferDefinitionVec &bufferDefs, CompositorNamedBufferVec &inOutBufContainer, const TextureGpu *finalTarget, RenderSystem *renderSys)
| Utility function to create the buffers based on a given set of buffer definitions and put them in a container.
static CompositorChannel | createTexture (const TextureDefinition &textureDef, const String &texName, const TextureGpu *finalTarget, RenderSystem *renderSys)
static void | createTextures (const TextureDefinitionVec &textureDefs, CompositorChannelVec &inOutTexContainer, IdType id, const TextureGpu *finalTarget, RenderSystem *renderSys)
| Utility function to create the textures based on a given set of texture definitions and put them in a container.
static void | destroyBuffers (const BufferDefinitionVec &bufferDefs, CompositorNamedBufferVec &inOutBufContainer, RenderSystem *renderSys)
static void | destroyTextures (CompositorChannelVec &inOutTexContainer, RenderSystem *renderSys)
static void | recreateResizableBuffers (const BufferDefinitionVec &bufferDefs, CompositorNamedBufferVec &inOutBufContainer, const TextureGpu *finalTarget, RenderSystem *renderSys, const CompositorNodeVec &connectedNodes, const CompositorPassVec *passes)
| Destroys & recreates only the buffers that depend on the main RT (i.e.
static void | recreateResizableTextures01 (const TextureDefinitionVec &textureDefs, CompositorChannelVec &inOutTexContainer, const TextureGpu *finalTarget)
| Destroys & recreates only the textures that depend on the main RT (e.g.
static void | recreateResizableTextures02 (const TextureDefinitionVec &textureDefs, CompositorChannelVec &inOutTexContainer, const CompositorNodeVec &connectedNodes, const CompositorPassVec *passes)
| See recreateResizableTextures01 Updates involved RenderPassDescriptors.
static void | setupTexture (TextureGpu *tex, const TextureDefinition &textureDef, const TextureGpu *finalTarget)

## Detailed Description

Centralized class for dealing with declarations of textures in Node & Workspace definitions.

Note that shadow nodes use their own system

Author
  Matias N. Goldberg

Version
  1.0

## Member Typedef Documentation

## ◆ BufferDefinitionVec

typedef vector<BufferDefinition>::type Ogre::TextureDefinitionBase::BufferDefinitionVec

## ◆ PixelFormatGpuVec

typedef vector<PixelFormatGpu>::type Ogre::TextureDefinitionBase::PixelFormatGpuVec

## ◆ TextureDefinitionVec

typedef vector<TextureDefinition>::type Ogre::TextureDefinitionBase::TextureDefinitionVec

## Member Enumeration Documentation

## ◆ TextureSource

enum Ogre::TextureDefinitionBase::TextureSource

Enumerator
TEXTURE_INPUT | We got the texture through an input channel.
TEXTURE_LOCAL | We own the texture.
TEXTURE_GLOBAL | It's a global texture. Ask the manager for it.
NUM_TEXTURES_SOURCES |

## Constructor & Destructor Documentation

## ◆ TextureDefinitionBase()

Ogre::TextureDefinitionBase::TextureDefinitionBase | ( | TextureSource | defaultSource | ) |

Referenced by Ogre::CompositorNodeDef::CompositorNodeDef().

## Member Function Documentation

## ◆ addBufferDefinition()

void Ogre::TextureDefinitionBase::addBufferDefinition | ( | IdString | name,
|  | size_t | numElements,
|  | uint32 | bytesPerElement,
|  | uint32 | bindFlags,
|  | float | widthFactor,
|  | float | heightFactor )

Creates an UAV buffer.

Parameters

  name | Name to give to this buffer for referencing it locally from this scope. Duplicate names (including names from addBufferInput) will raise an exception when trying to instantiate the workspace.
  bindFlags | Bitmask.

See also
  BufferBindFlags

Parameters

  widthFactor |

See also
  BufferDefinition::widthFactor

Parameters

  heightFactor |

See also
  BufferDefinition::widthFactor

## ◆ addBufferInput()

virtual void Ogre::TextureDefinitionBase::addBufferInput | ( | size_t | inputChannel,
|  | IdString | name )
| virtual

Buffers.

Specifies that buffer incoming from channel 'inputChannel' will be referenced by the name 'name'

Remarks
  Don't leave gaps. (i.e. set channel 0 & 2, without setting channel 1) It's ok to map them out of order (i.e. set channel 2, then 0, then 1)

Parameters

  inputChannel | Input channel # the buffer comes from.
  name | Name to give to this buffer for referencing it locally from this scope. Duplicate names (including names from addBufferDefinition) will raise an exception when trying to instantiate the workspace.

Reimplemented in Ogre::CompositorShadowNodeDef.

## ◆ addRenderTextureView()

RenderTargetViewDef * Ogre::TextureDefinitionBase::addRenderTextureView | ( | IdString | name | ) |

## ◆ addTextureDefinition()

TextureDefinition * Ogre::TextureDefinitionBase::addTextureDefinition | ( | const String & | name | ) |

Creates a TextureDefinition with a given name, must be unique.

Remarks
  WARNING: Calling this function may invalidate all previous returned pointers unless you've properly called setLocalTextureDefinitions

  See addTextureSourceName() remarks for what it can throw

  Textures are local when the derived class is a Node definition, and it's global when the derived class is a Workspace definition

Parameters

  name | The name of the texture. Names are usually valid only throughout this node. We need the name, not its hash because we need to validate the global_ prefix is used correctly.

## ◆ addTextureSourceName()

virtual IdString Ogre::TextureDefinitionBase::addTextureSourceName | ( | const String & | name,
|  | size_t | index,
|  | TextureSource | textureSource )
| virtual

Adds a texture name, whether a real one or an alias, and where to grab it from.

Remarks
  Throws if a texture with same name already exists, or if the name makes improper usage of the 'global' prefix.

  This is a generic way to add input channels, by calling:

      addTextureSourceName( "myRT", 0, TextureDefinitionBase::TEXTURE_INPUT );

You're assigning an alias named "myRT" to channel Input #0 For local or global textures, the index parameter documentation

Parameters

  name | The name of the texture. Names are usually valid only throughout this node. We need the name, not its hash because we need to validate the global_ prefix is used correctly.
  index | Index in the container where the texture is located, eg. this->mLocalTextureDefs[index] for local textures, workspace->mLocalTextureDefs[index] for global textures, and this->mInTextures[index] for input channels.
  textureSource | Source where the index must be used (eg. TEXTURE_LOCAL means mLocalTextureDefs)

Returns
  IdString of the fullName paremeter, for convenience

Reimplemented in Ogre::CompositorShadowNodeDef.

## ◆ createBuffer()

UavBufferPacked * Ogre::TextureDefinitionBase::createBuffer | ( | const BufferDefinition & | bufferDef,
|  | const TextureGpu * | finalTarget,
|  | VaoManager * | vaoManager )
| static

## ◆ createBuffers()

void Ogre::TextureDefinitionBase::createBuffers | ( | const BufferDefinitionVec & | bufferDefs,
|  | CompositorNamedBufferVec & | inOutBufContainer,
|  | const TextureGpu * | finalTarget,
|  | RenderSystem * | renderSys )
| static

Utility function to create the buffers based on a given set of buffer definitions and put them in a container.

Remarks
  Useful because both Workspace & CompositorNode share the same functionality (create global/local buffers respectively) without having to create a whole base class just for one function. It's confusing that Nodes & Workspace would share the same base class, as if they were the same base object or share similar functionality (when in fact, workspace manages nodes)

## ◆ createTexture()

CompositorChannel Ogre::TextureDefinitionBase::createTexture | ( | const TextureDefinition & | textureDef,
|  | const String & | texName,
|  | const TextureGpu * | finalTarget,
|  | RenderSystem * | renderSys )
| static

## ◆ createTextures()

void Ogre::TextureDefinitionBase::createTextures | ( | const TextureDefinitionVec & | textureDefs,
|  | CompositorChannelVec & | inOutTexContainer,
|  | IdType | id,
|  | const TextureGpu * | finalTarget,
|  | RenderSystem * | renderSys )
| static

Utility function to create the textures based on a given set of texture definitions and put them in a container.

Remarks
  Useful because both Workspace & CompositorNode share the same functionality (create global/local textures respectively) without having to create a whole base class just for one function. It's confusing that Nodes & Workspace would share the same base class, as if they were the same base object or share similar functionality (when in fact, workspace manages nodes)

Parameters

  textureDefs | Array of texture definitions
  inOutTexContainer | Where we'll store the newly created RTs & textures
  id | Unique id in the case we want textures to have unique names (uniqueNames must be true)
  uniqueNames | Set to true if each RT will have a unique name based on given Id, or we don't. The latter is useful for global textures (let them get access through materials)
  finalTarget | The final render target (usually the render window) we have to clone parameters from (eg. when using auto width & height, or fsaa settings)
  renderSys | The RenderSystem to use

## ◆ destroyBuffers()

void Ogre::TextureDefinitionBase::destroyBuffers | ( | const BufferDefinitionVec & | bufferDefs,
|  | CompositorNamedBufferVec & | inOutBufContainer,
|  | RenderSystem * | renderSys )
| static

See also
  createBuffers We need the definition because, unlike textures, the container passed in may contain textures that were not created by us (i.e. global & input textures) that we shouldn't delete. It is illegal for two buffers to have the same name, so it's invalid that a e.g. an input and a local texture would share the same name.

## ◆ destroyTextures()

void Ogre::TextureDefinitionBase::destroyTextures | ( | CompositorChannelVec & | inOutTexContainer,
|  | RenderSystem * | renderSys )
| static

See also
  createTextures

## ◆ getLocalBufferDefinitions()

const BufferDefinitionVec & Ogre::TextureDefinitionBase::getLocalBufferDefinitions | ( |  | ) | const
| inline

## ◆ getLocalBufferDefinitionsNonConst()

BufferDefinitionVec & Ogre::TextureDefinitionBase::getLocalBufferDefinitionsNonConst | ( |  | ) |
| inline

Returns the local buffer definitions.

Remarks
  WARNING: Use with care. You should not add/remove elements or change the name

See also
  addBufferDefinition,
  removeBuffer and
  renameBuffer to perform these actions

## ◆ getLocalTextureDefinitions()

const TextureDefinitionVec & Ogre::TextureDefinitionBase::getLocalTextureDefinitions | ( |  | ) | const
| inline

## ◆ getLocalTextureDefinitionsNonConst()

TextureDefinitionVec & Ogre::TextureDefinitionBase::getLocalTextureDefinitionsNonConst | ( |  | ) |
| inline

Returns the local texture definitions.

Remarks
  WARNING: Use with care. You should not add/remove elements or change the name as mNameToChannelMap needs to be kept in sync.

See also
  addTextureDefinition,
  removeTexture and
  renameTexture to perform these actions

## ◆ getNameToChannelMap()

const NameToChannelMap & Ogre::TextureDefinitionBase::getNameToChannelMap | ( |  | ) | const
| inline

## ◆ getNumInputBufferChannels()

size_t Ogre::TextureDefinitionBase::getNumInputBufferChannels | ( |  | ) | const

## ◆ getNumInputChannels()

size_t Ogre::TextureDefinitionBase::getNumInputChannels | ( |  | ) | const

This has O(N) complexity! (not cached, we look in mNameToChannelMap).

## ◆ getRenderTargetViewDef()

const RenderTargetViewDef * Ogre::TextureDefinitionBase::getRenderTargetViewDef | ( | IdString | name | ) | const

## ◆ getRenderTargetViewDefNonConstNoThrow()

RenderTargetViewDef * Ogre::TextureDefinitionBase::getRenderTargetViewDefNonConstNoThrow | ( | IdString | name | ) |

## ◆ getTextureSource()

void Ogre::TextureDefinitionBase::getTextureSource | ( | IdString | name,
|  | size_t & | index,
|  | TextureSource & | textureSource ) const

Retrieves in which container to look for when looking to which texture is a given name associated with.

Remarks
  Throws if name is not found.

Parameters

  name | The name of the texture. Names are usually valid only throughout this node.
  index | [out] The index at the container in which the texture associated with the output channel is stored
  textureSource | [out] Where to get this texture from

## ◆ recreateResizableBuffers()

void Ogre::TextureDefinitionBase::recreateResizableBuffers | ( | const BufferDefinitionVec & | bufferDefs,
|  | CompositorNamedBufferVec & | inOutBufContainer,
|  | const TextureGpu * | finalTarget,
|  | RenderSystem * | renderSys,
|  | const CompositorNodeVec & | connectedNodes,
|  | const CompositorPassVec * | passes )
| static

Destroys & recreates only the buffers that depend on the main RT (i.e.

the RenderWindow) resolution

Parameters

  textureDefs | Array of texture definitions, so we know which ones depend on main RT's resolution
  inOutTexContainer | Where we'll replace the RTs & textures
  finalTarget | The final render target (usually the render window) we have to clone parameters from (eg. when using auto width & height, or fsaa settings)
  renderSys | The RenderSystem to use
  connectedNodes | Array of connected nodes that may be using our buffers and need to be notified.
  passes | Array of Compositor Passes which may contain the texture being recreated When the pointer is null, we don't iterate through it.

## ◆ recreateResizableTextures01()

void Ogre::TextureDefinitionBase::recreateResizableTextures01 | ( | const TextureDefinitionVec & | textureDefs,
|  | CompositorChannelVec & | inOutTexContainer,
|  | const TextureGpu * | finalTarget )
| static

Destroys & recreates only the textures that depend on the main RT (e.g.

the Render Window) resolution.

Remarks
  This is divided in two steps: recreateResizableTextures01 & recreateResizableTextures02 since in some cases in RenderPassDescriptor, setting up MRT and depth textures requires all textures to be up to date, otherwise validation errors would occur since we'll have partial data (e.g. MRT 0 is 1024x768 while MRT 1 is 800x600)

Parameters

  textureDefs | Array of texture definitions, so we know which ones depend on main RT's resolution
  inOutTexContainer | Where we'll replace the RTs & textures
  finalTarget | The final render target (usually the render window) we have to clone parameters from (eg. when using auto width & height, or fsaa settings)

## ◆ recreateResizableTextures02()

void Ogre::TextureDefinitionBase::recreateResizableTextures02 | ( | const TextureDefinitionVec & | textureDefs,
|  | CompositorChannelVec & | inOutTexContainer,
|  | const CompositorNodeVec & | connectedNodes,
|  | const CompositorPassVec * | passes )
| static

See recreateResizableTextures01 Updates involved RenderPassDescriptors.

Parameters

  connectedNodes | Array of connected nodes that may be using our textures and need to be notified.
  passes | Array of Compositor Passes which may contain the texture being recreated When the pointer is null, we don't iterate through it.

## ◆ removeAllRenderTextureViews()

void Ogre::TextureDefinitionBase::removeAllRenderTextureViews | ( |  | ) |

## ◆ removeBuffer()

virtual void Ogre::TextureDefinitionBase::removeBuffer | ( | IdString | name | ) |
| virtual

Remove a buffer. Buffer can come from an input channel, or a locally defined one.

## ◆ removeRenderTextureView()

void Ogre::TextureDefinitionBase::removeRenderTextureView | ( | IdString | name | ) |

## ◆ removeTexture()

virtual void Ogre::TextureDefinitionBase::removeTexture | ( | IdString | name | ) |
| virtual

WARNING: Be very careful with this function.

Removes a texture.

- If the texture is from an input channel (TEXTURE_INPUT), the input channel is removed.
- If the texture is a local definition (TEXTURE_LOCAL) the texture definition is removed and all the references to mLocalTextureDefs[i+1] ... mLocalTextureDefs[i+n] are updated. However, the output channels will now contain an invalid index and will only be removed if it was the last output channel (since we can't alter the order). It is your responsability to call CompositorNodeDef::mapOutputChannel again with a valid texture name to the channel it was occupying.
- If the texture is a global texture (TEXTURE_GLOBAL), the global texture can no longer be accessed until addTextureSourceName( name, 0, TEXTURE_GLOBAL ) is called again.
  Parameters

    name | Name of the texture to remove.

Reimplemented in Ogre::CompositorNodeDef.

## ◆ renameBuffer()

void Ogre::TextureDefinitionBase::renameBuffer | ( | IdString | oldName,
|  | const String & | newName )

Changes the name of a buffer.

Buffer can come from an input channel, or a locally defined one.

## ◆ renameTexture()

void Ogre::TextureDefinitionBase::renameTexture | ( | IdString | oldName,
|  | const String & | newName )

Changes the name of a texture.

Texture can come from an input channel, be a global texture, or a locally defined one. You can't rename a global texture to avoid the "global_" prefix, or add the "global_" prefix to a texture that wasn't global.

## ◆ setNumLocalBufferDefinitions()

void Ogre::TextureDefinitionBase::setNumLocalBufferDefinitions | ( | size_t | numTDs | ) |
| inline

Reserves enough memory for all texture definitions.

Remarks
  Calling this function is not obligatory, but recommended

Parameters

  numTDs | The number of texture definitions expected to contain.

## ◆ setNumLocalTextureDefinitions()

void Ogre::TextureDefinitionBase::setNumLocalTextureDefinitions | ( | size_t | numTDs | ) |
| inline

Reserves enough memory for all texture definitions.

Remarks
  Calling this function is not obligatory, but recommended

Parameters

  numTDs | The number of texture definitions expected to contain.

## ◆ setupTexture()

void Ogre::TextureDefinitionBase::setupTexture | ( | TextureGpu * | tex,
|  | const TextureDefinition & | textureDef,
|  | const TextureGpu * | finalTarget )
| static

The documentation for this class was generated from the following file:

- OgreTextureDefinition.h